// This file is part of VPL for Moodle - http://vpl.dis.ulpgc.es/
//
// VPL for Moodle is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// VPL for Moodle is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with VPL for Moodle.  If not, see <http://www.gnu.org/licenses/>.

/**
 * JavaScript functions to update submission list grade
 * @package mod_vpl
 * @copyright 2012 Juan Carlos Rodríguez-del-Pino
 * @license http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
 * @author Juan Carlos Rodríguez-del-Pino <jcrodriguez@dis.ulpgc.es>
 */

/* globals VPL: true */

(function(){
    if (typeof VPL != 'object') {
        VPL = {};
    }

    VPL.sethlrow = function(subid, hl){
        if(opener === null){
            return;
        }
        var divsgrade = opener.document.getElementsByClassName('gd' + subid);
        Array.from(divsgrade).forEach(element => element.classList[hl ? 'add' : 'remove']('gradehighlight'));
    }

    /**
     * Update submission list grade
     * @param subid submission identification
    */
    VPL.updatesublist = function(subid, grade, grader, gradeon){
        if(opener === null){
            return;
        }
        var ssubid = "" + subid;
        var divgrade = opener.document.getElementById('g' + ssubid);
        var divgrader = opener.document.getElementById('m' + ssubid);
        var divgradeon = opener.document.getElementById('o' + ssubid);
        if (divgrade) {
            divgrade.innerHTML = grade;
        }
        if (divgrader) {
            divgrader.innerHTML = grader;
        }
        if (divgradeon) {
            divgradeon.innerHTML = gradeon;
        }
        VPL.sethlrow(subid, false);
    };

    /**
     * Go to next submission
     * @param subid submission id
     * @param url base of next
    */
    VPL.go_next = function(subid, url){
        if (opener === null) {
            window.close();
        }
        var ssubid = "" + subid;
        var divnext = opener.document.getElementById('n' + ssubid);
        if (divnext) {
            location.replace(url + divnext.innerHTML);
        }else{
            window.close();
        }
    };
})();
